package test;

import javax.enterprise.context.spi.CreationalContext;
import javax.enterprise.event.Observes;
import javax.enterprise.inject.spi.AfterDeploymentValidation;
import javax.enterprise.inject.spi.Bean;
import javax.enterprise.inject.spi.BeanManager;
import javax.enterprise.inject.spi.Extension;
import java.lang.annotation.Annotation;
import java.util.Set;

/**
 * TODO document
 *
 * @author Lars-Fredrik Smedberg (LASM02)
 */
public class ApplicationScopedExtension implements Extension {

    @SuppressWarnings("ResultOfMethodCallIgnored")
    void afterDeploymentValidation(@Observes AfterDeploymentValidation event, BeanManager beanManager) {

        System.out.println("---> ApplicationScopedExtension, AfterDeploymentValidation event received, before looking up and touching @ApplicationScoped dummy bean");

        ApplicationScopedDummyBean applicationScopedDummyBean = getContextualReference(beanManager, ApplicationScopedDummyBean.class);
        applicationScopedDummyBean.toString();

        System.out.println("---> ApplicationScopedExtension, after looking up and touching @ApplicationScoped dummy bean");
    }

    @SuppressWarnings("unchecked")
    private static <T> T getContextualReference(BeanManager beanManager, Class<T> type, Annotation... qualifiers) {

        Set<Bean<?>> beans = beanManager.getBeans(type, qualifiers);
        Bean<?> bean = beanManager.resolve(beans);
        CreationalContext<?> creationalContext = beanManager.createCreationalContext(bean);
        return (T) beanManager.getReference(bean, type, creationalContext);
    }
}
